/*
  The contents of this file are subject to the University of Utah Public
  License (the "License"); you may not use this file except in
  compliance with the License.
  
  Software distributed under the License is distributed on an "AS IS"
  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See
  the License for the specific language governing rights and limitations
  under the License.

  The Original Source Code is "teem", released March 23, 2001.
  
  The Original Source Code was developed by the University of Utah.
  Portions created by UNIVERSITY are Copyright (C) 2001, 1998 University
  of Utah. All Rights Reserved.
*/


#include "air.h"
#include <teem/need/endian.h>

/*
******** int airMyEndian
**
** it gets set to 1234 or 4321
*/
#if TEEM_ENDIAN == 1234
const int airMyEndian = 1234;
#else
const int airMyEndian = 4321;
#endif

int
airStrToEndian(char *str) {
  char *c, *tmp;
  int ret;

  ret = airEndianUnknown;
  if (str) {
    if ((tmp = airStrdup(str))) {
      c = tmp;
      while (*c) {
	*c = tolower(*c);
	c++;
      }
      if (!strncmp("big", tmp, 3)) {
	ret = airEndianBig;
      }
      else if (!strncmp("little", tmp, 6)) {
	ret = airEndianLittle;
      }
      free(tmp);
    }
  }  
  return ret;
}


const char *
airEndianToStr(int endian) {
  static const char what[]="(unknown endian)";
  static const char lit[]="little";
  static const char big[]="big";
  static const char *ret;
  
  switch(endian) {
  case airEndianLittle:
    ret = lit;
    break;
  case airEndianBig:
    ret = big;
    break;
  default:
    ret = what;
    break;
  }
  return ret;
}
